library make_asi;

uses
  Windows,
  kol,
  CGTShare in '..\..\CGTShare.pas';

type
  TCGrec = record
    MainForm:string;
    Units,IBody:PStrList;
  end;
  PCGrec = ^TCGrec;

function buildGetParamsProc(var params:TBuildParams):integer; cdecl;
begin
  params.flags := CGMP_COMPRESSED;
  Result := CG_SUCCESS;
end;

function buildMakePrj(const params:TBuildMakePrjRec):integer; cdecl;
var Res:PStrList;
    i:integer;
    P:PCGrec;
begin
   p := params.result;
   Res := NewStrList;
   Res.Add('library HiAsm;');
   Res.Add('{$ifdef F_P} {$SMARTLINK OFF} {$endif}');
   Res.Add('{$R allres.res}');
   Res.Add('uses ');
   for i := 0 to p.Units.Count-1 do
     Res.Add('   ' + p.Units.Items[i] + ',');
   Res.Add('  kol,Share;');
   Res.Add('');
   Res.Add('procedure EntryPoint(Reason: dword);');
   Res.Add('begin  ');
   Res.Add(' case Reason of  ');
   Res.Add('  1:   ');
   Res.Add('  _hi_onEvent(ClassMain.' + p.MainForm + '._event_onEntryPointProcessAttach);');
   Res.Add('  2:   ');
   Res.Add('  _hi_onEvent(ClassMain.' + p.MainForm + '._event_onEntryPointThreadAttach);');
   Res.Add('  3:   ');
   Res.Add('  _hi_onEvent(ClassMain.' + p.MainForm + '._event_onEntryPointThreadDetach);');
   Res.Add('  0:   ');
   Res.Add('  _hi_onEvent(ClassMain.' + p.MainForm + '._event_onEntryPointProcessDetach);');
   Res.Add(' end; // case   ');
   Res.Add('end; ');
   Res.Add('');
   Res.Add('begin');
   Res.Add('  ClassMain := TClass' + p.MainForm + '.Create;');
   Res.Add('DLLProc := @EntryPoint;');
   Res.Add('EntryPoint(DLL_PROCESS_ATTACH);');
   Res.Add('end.');

   Res.SaveToFile(params.prjFilename);
   Res.free;

   Result := CG_SUCCESS;
end;

function buildCompliteProc(const params:TBuildCompliteRec):integer; cdecl;
var src:string;
begin
  src := ExtractFilePath(params.prjFilename) + ExtractFileNameWOext(params.prjFilename) + '.dll';
  MoveFile(PChar(src), PChar(params.appFilename));
  Result := CG_SUCCESS;
end;

exports
    buildGetParamsProc,
    buildMakePrj,
    buildCompliteProc;

begin
end.
 